config/routes.rb
Rails.application.routes.draw do
  get '/', to: 'series#index'
  namespace :series do
    get ':series_id/episodes/*episode_id', to: 'episodes#show', as: 'show_episode'
  end
  get 'series/:id', to: 'series#show', as: 'show_series'
  get 'series/', to: 'series#index', as: 'series'
  post 'series/new/', to: 'series#create', as: 'create_series'
  post 'series/:id/ordering', to: 'series#update_ordering', as: 'update_ordering'
  post 'series/:id/update', to: 'series#update', as: 'update_series'

  delete 'series/:id', to: 'series#delete', as: 'delete_series'
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/episode.rb
class Episode < ApplicationRecord
  belongs_to :series
end

app/models/series.rb
# frozen_string_literal: true

require 'russ'
require 'open-uri'

class Series < ApplicationRecord
  has_many :episodes

  def feed
    return @feed if @feed

    URI.parse(url).open do |rss|
      charset = rss.charset { Encoding.default_external }
      rss.set_encoding(charset)
      content = rss.read
      @feed = Russ::Channel.from_s(content)
    end

    @feed
  end

  def self.from_url(url)
    result = Series.new(url:)

    result.update
  end

  def update
    @feed = nil

    puts feed.image.inspect
    self.title = feed.title
    self.image = feed.image.url
    self.description = feed.description

    save

    SyncEpisodesJob.perform_now(self)
  end

  def oldest_first?
    ordering == 1
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  def route_name
    (Rails.application.routes.recognize_path request.fullpath)[:controller]
  end

  def proxy_image(url, width: 240, height: 240)
    return unless url

    Imgproxy.url_for(
      url,
      width:,
      height:
    )
  end

  helper_method :route_name
  helper_method :proxy_image
end

app/controllers/series/episodes_controller.rb
class Series::EpisodesController < ApplicationController
  def show
    @series = Series.find(params[:series_id])

    @episode = @series.episodes.find do |item|
      id = params[:episode_id]
      item.guid.sub(%r{/+}, '/') == id
    end
  end
end

app/controllers/series_controller.rb
# frozen_string_literal: true

require 'json/ext'

class SeriesController < ApplicationController
  def show
    @series = Series.find(params[:id])
    respond_to do |format|
      format.json do
        render json: @series.feed.to_json
      end
      format.html do
        render 'series/show'
      end
    end
  end

  def index
    @all_series = Series.all
  end

  def create
    Series.from_url(params[:url])

    redirect_to action: :index
  end

  def update
    series = Series.find(params[:id])

    series.update

    redirect_to action: :show
  end

  def update_ordering
    @series = Series.find(params[:id])

    new_ordering = params[:ordering]

    @series.ordering = new_ordering
    @series.save

    redirect_to action: :show
  end

  def delete
    series = Series.find(id: params.id)
    series.destroy
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/series/episodes_helper.rb
module Series::EpisodesHelper
end

app/helpers/series_helper.rb
module SeriesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Mousepod</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%= stylesheet_link_tag "application" %>
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Inconsolata:wght@500&display=swap" rel="stylesheet">
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/series/_header.slim
header data-route=route_name
  nav
    a href=series_path
      img src="https://icongr.am/feather/home.svg?size=32&color=FEDBC7"
  .pod-description
    section
      h1 #{@series.title}
      p.description-text==@series.description

      == form_with url: update_ordering_path(@series), method: :post do |form|
        select name="ordering"
          option value="0" Newest first
          option value="1" selected=@series.oldest_first? Oldest first
        input type="submit" value="Update"

      == form_with url: update_series_path(@series), method: :post do |form|
        input type="submit" value="Refresh"
    section
      img src=proxy_image(@series.image, width: 300, height: 300)

app/views/series/episodes/_list.html.slim
div style="overflow-y: auto; flex-grow: 1"
  ul.episode-list
    - if @series.oldest_first?
      - @series.episodes.reverse_each do |item|
        == render partial: 'series/episodes/list_item', locals: {item:}
    - else 
      - @series.episodes.each do |item|
        == render partial: 'series/episodes/list_item', locals: {item:}

app/views/series/episodes/_list_item.html.slim
li 
  == link_to item.title, series_show_episode_path(@series, item.guid)

app/views/series/episodes/show.html.slim
== render '/series/header'

main data-route=route_name

  == render 'list'

  div style="padding: 1em; flex-basis: fit-content; overflow-y: auto;"
    h1=@episode.title
    small=@episode.added_on
    ==@episode.description

    audio controls=true src=@episode.audio

app/views/series/index.html.slim
p
  h1 Add a new series
  == form_with url: create_series_path, method: :post do |form|
    label
      | Feed URL: 
      input type="url" name="url" id="url"

    input type="submit" value="Add"

div style="display: flex; flex-wrap: wrap; overflow-y: auto;"
  - @all_series.each do |series|
    - if series&.image
      a href=show_series_path(series)
        img class="cover-art" src=proxy_image(series.image)

app/views/series/show.html.slim
== render 'header'

main
  == render '/series/episodes/list'